<html>
<head>
<title>OgreQuaternion.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreQuaternion.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreQuaternion_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="comment">// This file is based on material originally from:</span>
<a name="l00029"></a>00029 <span class="comment">// Geometric Tools, LLC</span>
<a name="l00030"></a>00030 <span class="comment">// Copyright (c) 1998-2010</span>
<a name="l00031"></a>00031 <span class="comment">// Distributed under the Boost Software License, Version 1.0.</span>
<a name="l00032"></a>00032 <span class="comment">// http://www.boost.org/LICENSE_1_0.txt</span>
<a name="l00033"></a>00033 <span class="comment">// http://www.geometrictools.com/License/Boost/LICENSE_1_0.txt</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifndef __Quaternion_H__</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#define __Quaternion_H__</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreMath_8h.html">OgreMath.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>Ogre {
<a name="l00043"></a>00043 
<a name="l00057"></a><a class="code" href="classOgre_1_1Quaternion.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00061"></a><a class="code" href="classOgre_1_1Quaternion.html#ab58dc0c4c04d0579ce9321a719f10d5c">00061</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> ()
<a name="l00062"></a>00062             : w(1), x(0), y(0), z(0)
<a name="l00063"></a>00063         {
<a name="l00064"></a>00064         }
<a name="l00066"></a><a class="code" href="classOgre_1_1Quaternion.html#a9b45997a81d85662350808b7043d535d">00066</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> (
<a name="l00067"></a>00067             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fW,
<a name="l00068"></a>00068             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fX, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fY, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fZ)
<a name="l00069"></a>00069             : w(fW), x(fX), y(fY), z(fZ)
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071         }
<a name="l00073"></a><a class="code" href="classOgre_1_1Quaternion.html#acdcb70a4f122452b6fa70d7cf5ce3cf3">00073</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; rot)
<a name="l00074"></a>00074         {
<a name="l00075"></a>00075             this-&gt;FromRotationMatrix(rot);
<a name="l00076"></a>00076         }
<a name="l00078"></a><a class="code" href="classOgre_1_1Quaternion.html#a7f25c623d95186b58f6367dcd097a5ba">00078</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080             this-&gt;FromAngleAxis(rfAngle, rkAxis);
<a name="l00081"></a>00081         }
<a name="l00083"></a><a class="code" href="classOgre_1_1Quaternion.html#a1140011dc0793a81c55f2d078c8c964c">00083</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; xaxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; yaxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; zaxis)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085             this-&gt;FromAxes(xaxis, yaxis, zaxis);
<a name="l00086"></a>00086         }
<a name="l00088"></a><a class="code" href="classOgre_1_1Quaternion.html#a3ccc60338011887023b397a02a7f3336">00088</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* akAxis)
<a name="l00089"></a>00089         {
<a name="l00090"></a>00090             this-&gt;FromAxes(akAxis);
<a name="l00091"></a>00091         }
<a name="l00093"></a><a class="code" href="classOgre_1_1Quaternion.html#a1ca81bd9d57e43cf23582c898e5fdd34">00093</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* valptr)
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095             memcpy(&amp;w, valptr, <span class="keyword">sizeof</span>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>)*4);
<a name="l00096"></a>00096         }
<a name="l00097"></a>00097 
<a name="l00100"></a><a class="code" href="classOgre_1_1Quaternion.html#a54dcd575915c7b7ddb65b8cb249de521">00100</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">swap</a>(<a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; other)
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(w, other.<a class="code" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">w</a>);
<a name="l00103"></a>00103             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(x, other.<a class="code" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">x</a>);
<a name="l00104"></a>00104             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(y, other.<a class="code" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">y</a>);
<a name="l00105"></a>00105             <a class="code" href="namespacestd.html#ac0f5c834836c0f5a4602cff74511d272" title="Implement std::swap in terms of SmallVector swap.">std::swap</a>(z, other.<a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a>);
<a name="l00106"></a>00106         }
<a name="l00107"></a>00107 
<a name="l00109"></a><a class="code" href="classOgre_1_1Quaternion.html#a3f9320930fd5110028abf48c78a89622">00109</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )<span class="keyword"> const</span>
<a name="l00110"></a>00110 <span class="keyword">        </span>{
<a name="l00111"></a>00111             assert( i &lt; 4 );
<a name="l00112"></a>00112 
<a name="l00113"></a>00113             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00114"></a>00114         }
<a name="l00115"></a>00115 
<a name="l00117"></a><a class="code" href="classOgre_1_1Quaternion.html#a074aea0da7fabfde89d204a1f0f0121b">00117</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>&amp; operator [] ( <span class="keyword">const</span> <span class="keywordtype">size_t</span> i )
<a name="l00118"></a>00118         {
<a name="l00119"></a>00119             assert( i &lt; 4 );
<a name="l00120"></a>00120 
<a name="l00121"></a>00121             <span class="keywordflow">return</span> *(&amp;w+i);
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123 
<a name="l00125"></a><a class="code" href="classOgre_1_1Quaternion.html#aecce24dd0096766de0c96c13b195b197">00125</a>         <span class="keyword">inline</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()
<a name="l00126"></a>00126         {
<a name="l00127"></a>00127             <span class="keywordflow">return</span> &amp;w;
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129 
<a name="l00131"></a><a class="code" href="classOgre_1_1Quaternion.html#ab4b5bc328439a4f96d1b4b413fcf87cc">00131</a>         <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a>* ptr()<span class="keyword"> const</span>
<a name="l00132"></a>00132 <span class="keyword">        </span>{
<a name="l00133"></a>00133             <span class="keywordflow">return</span> &amp;w;
<a name="l00134"></a>00134         }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         <span class="keywordtype">void</span> FromRotationMatrix (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kRot);
<a name="l00137"></a>00137         <span class="keywordtype">void</span> ToRotationMatrix (<a class="code" href="classOgre_1_1Matrix3.html" title="A 3x3 matrix which can represent rotations around axes.">Matrix3</a>&amp; kRot) <span class="keyword">const</span>;
<a name="l00141"></a>00141         <span class="keywordtype">void</span> FromAngleAxis (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis);
<a name="l00142"></a>00142         <span class="keywordtype">void</span> ToAngleAxis (<a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; rfAngle, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis) <span class="keyword">const</span>;
<a name="l00143"></a><a class="code" href="classOgre_1_1Quaternion.html#a77b776c2f81d371549927b0f79478eb9">00143</a>         <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1Quaternion.html#a77b776c2f81d371549927b0f79478eb9">ToAngleAxis</a> (<a class="code" href="classOgre_1_1Degree.html" title="Wrapper class which indicates a given angle value is in Degrees.">Degree</a>&amp; dAngle, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkAxis)<span class="keyword"> const </span>{
<a name="l00144"></a>00144             <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> rAngle;
<a name="l00145"></a>00145             ToAngleAxis ( rAngle, rkAxis );
<a name="l00146"></a>00146             dAngle = rAngle;
<a name="l00147"></a>00147         }
<a name="l00151"></a>00151         <span class="keywordtype">void</span> FromAxes (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* akAxis);
<a name="l00152"></a>00152         <span class="keywordtype">void</span> FromAxes (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; xAxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; yAxis, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; zAxis);
<a name="l00154"></a>00154         <span class="keywordtype">void</span> ToAxes (<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>* akAxis) <span class="keyword">const</span>;
<a name="l00155"></a>00155         <span class="keywordtype">void</span> ToAxes (<a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; xAxis, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; yAxis, <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; zAxis) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00160"></a>00160         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> xAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00161"></a>00161 
<a name="l00165"></a>00165         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> yAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00166"></a>00166 
<a name="l00170"></a>00170         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> zAxis(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classOgre_1_1Quaternion.html#a6367b543cf0d073d893139dd503b4fbd">00172</a>         <span class="keyword">inline</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; operator= (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ)
<a name="l00173"></a>00173         {
<a name="l00174"></a>00174             w = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">w</a>;
<a name="l00175"></a>00175             x = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">x</a>;
<a name="l00176"></a>00176             y = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">y</a>;
<a name="l00177"></a>00177             z = rkQ.<a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a>;
<a name="l00178"></a>00178             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00179"></a>00179         }
<a name="l00180"></a>00180         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator+ (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00181"></a>00181         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator- (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00182"></a>00182         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00183"></a>00183         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar) <span class="keyword">const</span>;
<a name="l00184"></a>00184         <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fScalar,
<a name="l00185"></a>00185             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ);
<a name="l00186"></a>00186         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> operator- () <span class="keyword">const</span>;
<a name="l00187"></a><a class="code" href="classOgre_1_1Quaternion.html#aa20c618a3b4b67d22d2cfd64ba2c8f3b">00187</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator== </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword">        </span>{
<a name="l00189"></a>00189             <span class="keywordflow">return</span> (rhs.<a class="code" href="classOgre_1_1Quaternion.html#a32c5680516b41bc4ba3159bf4d4abaf1">x</a> == x) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1Quaternion.html#aa7328cd3883a92ee9c9322805d038f11">y</a> == y) &amp;&amp;
<a name="l00190"></a>00190                 (rhs.<a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a> == z) &amp;&amp; (rhs.<a class="code" href="classOgre_1_1Quaternion.html#af3424f1e07092c0ffe293d18b277a04f">w</a> == w);
<a name="l00191"></a>00191         }
<a name="l00192"></a><a class="code" href="classOgre_1_1Quaternion.html#aaac827806910efa70a5deaa6d75bf3e1">00192</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="group__Memory.html#ga34a9308dc656f694883718bf8fa4f1c2" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs)<span class="keyword"> const</span>
<a name="l00193"></a>00193 <span class="keyword">        </span>{
<a name="l00194"></a>00194             <span class="keywordflow">return</span> !<a class="code" href="group__Memory.html#gaa5b83b2ba3ce965e3d8dd129c93ee43b" title="determine equality, can memory from another allocator be released by this allocator, (ISO C++)">operator==</a>(rhs);
<a name="l00195"></a>00195         }
<a name="l00196"></a>00196         <span class="comment">// functions of a quaternion</span>
<a name="l00198"></a>00198 <span class="comment"></span>        <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Dot (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ) <span class="keyword">const</span>;
<a name="l00199"></a>00199         <span class="comment">/* Returns the normal length of this quaternion.</span>
<a name="l00200"></a>00200 <span class="comment">            @note This does &lt;b&gt;not&lt;/b&gt; alter any values.</span>
<a name="l00201"></a>00201 <span class="comment">        */</span>
<a name="l00202"></a>00202         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> Norm () <span class="keyword">const</span>;
<a name="l00204"></a>00204         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> normalise(<span class="keywordtype">void</span>); 
<a name="l00205"></a>00205         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Inverse () <span class="keyword">const</span>;  <span class="comment">// apply to non-zero quaternion</span>
<a name="l00206"></a>00206         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> UnitInverse () <span class="keyword">const</span>;  <span class="comment">// apply to unit-length quaternion</span>
<a name="l00207"></a>00207         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Exp () <span class="keyword">const</span>;
<a name="l00208"></a>00208         <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Log.html">Log</a> () <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00211"></a>00211         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="group__Math.html#ga03482705bf3612c6b96e5a187095e8ac">operator* </a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; rkVector) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00222"></a>00222         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getRoll(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00232"></a>00232         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getPitch(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00242"></a>00242         <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a> getYaw(<span class="keywordtype">bool</span> reprojectAxis = <span class="keyword">true</span>) <span class="keyword">const</span>;     
<a name="l00244"></a>00244         <span class="keywordtype">bool</span> equals(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rhs, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; tolerance) <span class="keyword">const</span>;
<a name="l00245"></a>00245         
<a name="l00258"></a>00258         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Slerp (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP,
<a name="l00259"></a>00259             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00260"></a>00260 
<a name="l00265"></a>00265         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> SlerpExtraSpins (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT,
<a name="l00266"></a>00266             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ,
<a name="l00267"></a>00267             <span class="keywordtype">int</span> iExtraSpins);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269         <span class="comment">// setup for spherical quadratic interpolation</span>
<a name="l00270"></a>00270         <span class="keyword">static</span> <span class="keywordtype">void</span> Intermediate (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ0,
<a name="l00271"></a>00271             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ1, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ2,
<a name="l00272"></a>00272             <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rka, <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkB);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274         <span class="comment">// spherical quadratic interpolation</span>
<a name="l00275"></a>00275         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> Squad (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP,
<a name="l00276"></a>00276             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkA, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkB,
<a name="l00277"></a>00277             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00278"></a>00278 
<a name="l00293"></a>00293         <span class="keyword">static</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> nlerp(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fT, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkP, 
<a name="l00294"></a>00294             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; rkQ, <span class="keywordtype">bool</span> shortestPath = <span class="keyword">false</span>);
<a name="l00295"></a>00295 
<a name="l00297"></a><a class="code" href="classOgre_1_1Quaternion.html#a6b53296360cc166c62533cff8f1edcc2">00297</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1Quaternion.html#a6b53296360cc166c62533cff8f1edcc2" title="Cutoff for sine near zero.">msEpsilon</a>;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299         <span class="comment">// special values</span>
<a name="l00300"></a><a class="code" href="classOgre_1_1Quaternion.html#a44f3c000c8f1ea2759c2e724e04bf86b">00300</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Quaternion.html#a44f3c000c8f1ea2759c2e724e04bf86b">ZERO</a>;
<a name="l00301"></a><a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">00301</a>         <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a> <a class="code" href="classOgre_1_1Quaternion.html#a441b8d52549e1dedec27420325a313ef">IDENTITY</a>;
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">00303</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> w, x, y, <a class="code" href="classOgre_1_1Quaternion.html#a31ec84a931236554c0c17e37bf5ace97">z</a>;
<a name="l00304"></a>00304 
<a name="l00306"></a><a class="code" href="classOgre_1_1Quaternion.html#a2b1de9aebae545618e105399aeee6f39">00306</a>         <span class="keyword">inline</span> <span class="keywordtype">bool</span> isNaN()<span class="keyword"> const</span>
<a name="l00307"></a>00307 <span class="keyword">        </span>{
<a name="l00308"></a>00308             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(x) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(y) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(z) || <a class="code" href="classOgre_1_1Math.html#a8e299aa79c3a90617cbe764ee977b703">Math::isNaN</a>(w);
<a name="l00309"></a>00309         }
<a name="l00310"></a>00310 
<a name="l00314"></a>00314         <span class="keyword">inline</span> <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <span class="keyword">friend</span> std::ostream&amp; <span class="keyword">operator</span> &lt;&lt;
<a name="l00315"></a><a class="code" href="classOgre_1_1Quaternion.html#a2a92fc4c7d55783c70ef6f633f3cac89">00315</a>             ( std::ostream&amp; o, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Quaternion.html" title="Implementation of a Quaternion, i.e.">Quaternion</a>&amp; q )
<a name="l00316"></a>00316         {
<a name="l00317"></a>00317             o &lt;&lt; <span class="stringliteral">&quot;Quaternion(&quot;</span> &lt;&lt; q.w &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.x &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.y &lt;&lt; <span class="stringliteral">&quot;, &quot;</span> &lt;&lt; q.z &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>;
<a name="l00318"></a>00318             <span class="keywordflow">return</span> o;
<a name="l00319"></a>00319         }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321     };
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="preprocessor">#endif </span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
